<script setup>
import { computed } from "vue";
import { useToolStore } from "@/stores/useToolStore";

const props = defineProps(["connectorType", "investigationId"]);
const ToolStore = useToolStore();
const currentConnector = ref(null);
const currentTool = ref(null);
const currentStep = ref("selectConnector");
const spinner = ref(false);

await ToolStore.fetchConnectors(props.connectorType);
await ToolStore.fetchTools(props.connectorType, props.investigationId);

const emits = defineEmits(["toolselected"]);

function setcurrentStep(step) {
  currentStep.value = step;
}

function selectConnector(connector) {
  currentConnector.value = connector;
  currentStep.value = "configureConnector";
}

async function selectTool(tool) {
  currentTool.value = tool;
  emits("toolselected", tool);
}

async function createNewTool() {
  spinner.value = true;
  try {
    let tool = await ToolStore.createTool(
      currentConnector.value,
      props.investigationId
    );
    selectTool(tool);
  } finally {
    spinner.value = false;
  }
}

const recoverFromError = (error) => {
  // Try to resolve the error here
  error.value = null;
};
</script>


<template>
  <v-row class="fill-height" v-if="currentStep == 'selectConnector'">
    <v-col>
      <b>Choose a tool</b>
      <p class="text-overline mb-0" v-if="ToolStore.tools.size > 0">
        Tools already used
      </p>
      <v-row class="mt-0" v-if="ToolStore.tools.size > 0">
        <v-col cols="4" v-for="tool in ToolStore.tools.values()">
            <v-card
                :title="ToolStore.connectors.get(tool.connector).name"
                :subtitle="tool.name"
                :prepend-avatar="ToolStore.connectors.get(tool.connector).icon"
                @click="selectTool(tool)"
                color="#F5F5F5"
                class="pa-0">
                <template v-slot:prepend>
                    <v-avatar rounded="0"></v-avatar>
                </template>
            </v-card>
        </v-col>
      </v-row>
      <p class="text-overline mb-0 mt-4" v-if="ToolStore.tools.size > 0">
        Other tools
      </p>
      <v-row class="mt-0">
        <v-col cols="4" v-for="connector in ToolStore.connectors.values()">
            <v-card
                :title="connector.name"
                :prepend-avatar="connector.icon"
                @click="selectConnector(connector)"
                color="#F5F5F5"
                class="pa-0">
                <template v-slot:prepend>
                    <v-avatar rounded="0"></v-avatar>
                </template>
            </v-card>
        </v-col>
      </v-row>
    </v-col>
    <v-divider class="mx-4" vertical></v-divider>
    <v-col cols="3"> </v-col>
  </v-row>

  <v-row class="fill-height" v-if="currentStep == 'configureConnector'">
    <v-col class="d-flex flex-column fill-height">
      <div>
        Complete the form below to connect to {{ currentConnector.name }}
      </div>
      <div v-for="field in currentConnector.fields" class="ma-0">
        <v-text-field
          v-if="field.type == 'text'"
          :label="field.name"
          :hint="field.helper"
          :name="field.id"
          v-model="field.value"
          @keyup.enter="createNewTool()"
        ></v-text-field>
        <v-text-field
          v-if="field.type == 'password'"
          type="password"
          :label="field.name"
          :hint="field.helper"
          :name="field.id"
          v-model="field.value"
          @keyup.enter="createNewTool()"
        ></v-text-field>
      </div>
      <div class="mt-auto d-flex flex-row">
        <v-btn
          size="small"
          color="primary"
          class="ml-auto"
          @click="setcurrentStep('selectConnector')"
          >Back</v-btn
        >
        <v-btn
          v-if="spinner == false"
          size="small"
          color="primary"
          class="ml-5"
          @click="createNewTool()"
          >Next</v-btn
        >
        <v-btn
          v-if="spinner == true"
          size="small"
          color="primary"
          class="ml-5"
          style="small"
        >
          <div class="spinner">
            <div class="bounce1"></div>
            <div class="bounce2"></div>
            <div class="bounce3"></div>
          </div>
        </v-btn>
      </div>
    </v-col>
    <v-divider class="mx-4" vertical></v-divider>
    <v-col cols="3">
      <v-avatar
        rounded="0"
        size="x-small"
        :image="currentConnector.icon"
        class="mr-1"
      ></v-avatar
      >{{ currentConnector.name }}

      <p class="mt-2">
        {{ currentConnector.description }}
      </p>
    </v-col>
  </v-row>

  <v-card width="400" v-if="error">
    <v-card-item>
      <v-card-title>This is a title</v-card-title>

      <v-card-subtitle>This is a subtitle</v-card-subtitle>
    </v-card-item>

    <v-card-text> This is content </v-card-text>
  </v-card>
</template>
